#include "Precompiled.h"
#include <ta_libc.h>
#include <stdlib.h>
#include "AsirikuyMachineLearningCWrapper.hpp"
#include "EasyTradeCWrapper.hpp"
#include "OrderSignals.h"
#include "OrderManagement.h"
#include "AsirikuyTime.h"
 
typedef enum additionalSettings_t
{
    TRADING_HOUR         = ADDITIONAL_PARAM_1,
	LEARNING_PERIOD      = ADDITIONAL_PARAM_2,
    BARS_USED            = ADDITIONAL_PARAM_3,
    FRONTIER             = ADDITIONAL_PARAM_4
} AdditionalSettings;
 
AsirikuyReturnCode runSH004(StrategyParams* pParams)
{
	double stopLoss, takeProfit, atr;
	int prediction[2];

	atr = iAtrWholeDaysSimpleShift(PRIMARY_RATES, (int)parameter(ATR_AVERAGING_PERIOD), 1);
	stopLoss   =  atr * parameter(SL_ATR_MULTIPLIER);
	takeProfit =  atr * parameter(TP_ATR_MULTIPLIER);
 
	if (hour() != (int)parameter(TRADING_HOUR))
		return SUCCESS;
      
	LR_Prediction_i_simpleReturn_o_tradeOutcomeSLTP((int)parameter(LEARNING_PERIOD),
													(int)parameter(BARS_USED), 
													(int)parameter(TRADING_HOUR), 
													parameter(SL_ATR_MULTIPLIER), 
													parameter(TP_ATR_MULTIPLIER), 
													(int)parameter(FRONTIER), 
													&prediction);
	if (prediction[0] == 1)
		openSingleLongEasy(takeProfit, stopLoss, 0);
  
	if (prediction[1] == 1)
		openSingleShortEasy(takeProfit, stopLoss, 0);
  
	return SUCCESS;
}